function varargout = GestureTweak(varargin)
% GESTURETWEAK M-file for GestureTweak.fig
%      GESTURETWEAK, by itself, creates a new GESTURETWEAK or raises the existing
%      singleton*.
%
%      H = GESTURETWEAK returns the handle to a new GESTURETWEAK or the handle to
%      the existing singleton*.
%
%      GESTURETWEAK('CALLBACK',hObject,eventData,handles,...) calls the
%      local
%      function named CALLBACK in GESTURETWEAK.M with the given input arguments.
%
%      GESTURETWEAK('Property','Value',...) creates a new GESTURETWEAK or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GestureTweak_OpeningFunction gets called.
%      An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GestureTweak_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help GestureTweak

% Last Modified by GUIDE v2.5 24-Mar-2006 16:55:02

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GestureTweak_OpeningFcn, ...
                   'gui_OutputFcn',  @GestureTweak_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GestureTweak is made visible.
function GestureTweak_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GestureTweak (see VARARGIN)

% Choose default command line output for GestureTweak
handles.output = hObject;
%%% hObject = gcf at this point...

% Initialize variables
handles.MinTimeStep = 20/1000;  % (sec) 
handles.NumServos = 12;     % Works for 12, there'd be trouble with other numbers... particularly with joint selection and naming
handles.distance = 20;      % Defines how "close" is good enough for point selection
handles.resample_points = 255;  % Number of points to generate for a resample
handles.slope_range = 1;        % Slope boundary for segment finding

% Servo #9 = FL Wing
handles.Servos(1).name = 'FL Wing';
handles.Servos(1).rev = false;
handles.Servos(1).uplabel = 'Up';
handles.Servos(1).downlabel = 'Down';
handles.Servos(1).num = 9;

% Servo #11 = FL Crank
handles.Servos(2).name = 'FL Crank';
handles.Servos(2).rev = true;
handles.Servos(2).uplabel = 'Forward';
handles.Servos(2).downlabel = 'Back';
handles.Servos(2).num = 11;

% Servo #1 = FL Toe
handles.Servos(3).name = 'FL Toe';
handles.Servos(3).num = 1;
handles.Servos(3).rev = false;
handles.Servos(3).uplabel = 'Up';
handles.Servos(3).downlabel = 'Down';

% Servo #0 = FR Wing
handles.Servos(4).name = 'FR Wing';
handles.Servos(4).num = 0;
handles.Servos(4).rev = true;
handles.Servos(4).uplabel = 'Up';
handles.Servos(4).downlabel = 'Down';

% Servo #2 = FR Crank
handles.Servos(5).name = 'FR Crank';
handles.Servos(5).num = 2;
handles.Servos(5).rev = true;
handles.Servos(5).uplabel = 'Forward';
handles.Servos(5).downlabel = 'Back';

% Servo #10 = FR Toe
handles.Servos(6).name = 'FR Toe';
handles.Servos(6).num = 10;
handles.Servos(6).rev = true;
handles.Servos(6).uplabel = 'Up';
handles.Servos(6).downlabel = 'Down';

% Servo #6 = RL Wing
handles.Servos(7).name = 'RL Wing';
handles.Servos(7).num = 6;
handles.Servos(7).rev = true;
handles.Servos(7).uplabel = 'Up';
handles.Servos(7).downlabel = 'Down';

% Servo #8 = RL Crank
handles.Servos(8).name = 'RL Crank';
handles.Servos(8).num = 8;
handles.Servos(8).rev = false;
handles.Servos(8).uplabel = 'Forward';
handles.Servos(8).downlabel = 'Back';

% Servo #4 = RL Toe
handles.Servos(9).name = 'RL Toe';
handles.Servos(9).num = 4;
handles.Servos(9).rev = true;
handles.Servos(9).uplabel = 'Up';
handles.Servos(9).downlabel = 'Down';

% Servo #3 = RR Wing
handles.Servos(10).name = 'RR Wing';
handles.Servos(10).num = 3;
handles.Servos(10).rev = false;
handles.Servos(10).uplabel = 'Up';
handles.Servos(10).downlabel = 'Down';

% Servo #5 = RR Crank
handles.Servos(11).name = 'RR Crank';
handles.Servos(11).num = 5;
handles.Servos(11).rev = true;
handles.Servos(11).uplabel = 'Forward';
handles.Servos(11).downlabel = 'Back';

% Servo #7 = RR Toe
handles.Servos(12).name = 'RR Toe';
handles.Servos(12).num = 7;
handles.Servos(12).rev = false;
handles.Servos(12).uplabel = 'Up';
handles.Servos(12).downlabel = 'Down';

handles.TimeInd = handles.NumServos+1;
handles.modified = false;
handles.showmarkers = false;
handles.CurrentServo = 1;

temp = handles.uipanel5;

set(handles.AddPointsButton,'Parent',temp);
set(handles.DeletePointsButton,'Parent',temp);
set(handles.MovePointsButton,'Parent',temp);

% Set up toolbar
handles.hToolbar = uitoolbar('Parent',gcf,'HandleVisibility','callback');
handles.hSavePushTool = uipushtool('Parent',handles.hToolbar,'TooltipString','Save Data File', ...
    'CData',importdata(fullfile(matlabroot,'toolbox','matlab','icons','savedoc.mat')),...
    'HandleVisibility','callback', 'ClickedCallback', @SaveMenuItem_Callback);

handles.hPrintPushTool = uitoolfactory(handles.hToolbar,'Standard.PrintFigure');
% hPrintPushTool = uipushtool('Parent',hToolbar,'TooltipString','Print Figure',...
%     'CData',importdata(fullfile(matlabroot,'toolbox','matlab','icons','printdoc.mat')),...
%     'HandleVisibility','callback', 'ClickedCallback', @PrintMenuItem_Callback);

handles.hEditPlotTool = uitoolfactory(handles.hToolbar,'Standard.EditPlot');
set(handles.hEditPlotTool,'Separator','on');

handles.hZoomInTool = uitoolfactory(handles.hToolbar,'Exploration.ZoomIn');
set(handles.hZoomInTool,'Separator','on');

handles.hZoomOutTool = uitoolfactory(handles.hToolbar,'Exploration.ZoomOut');

handles.hPanTool = uitoolfactory(handles.hToolbar,'Exploration.Pan');

handles.hDataCursorTool = uitoolfactory(handles.hToolbar,'Exploration.DataCursor');
set(handles.hDataCursorTool,'Separator','on');
% hDataCursorTool = uitoggletool('Parent',hToolbar,'TooltipString','Data Cursor', ...
%     'CData',importdata(fullfile(matlabroot,'toolbox','matlab','icons','datatip.mat')),...
%     'HandleVisibility','callback','ClickedCallback',@DataCursorTool_Callback);

guidata(hObject,handles);  % Save data to figure

vars = evalin('base','whos');
handles.vars_mats = [];
for i=1:size(vars,1)
    if vars(i).size(2) == handles.TimeInd
        handles.vars_mats = strvcat(handles.vars_mats,vars(i).name);
    end
end

if(size(handles.vars_mats,1)==0)
    set(handles.GaitMatrixSelect,'String',' ')
    handles.servmat=ones(2,handles.TimeInd); 
else
    set(handles.GaitMatrixSelect,'String',handles.vars_mats)
    handles.servmat = evalin('base',handles.vars_mats(1,:));
    % Added by BEH 3/23
    handles.resample_points = size(handles.servmat,1);
    % end addition
end
handles=UpdateTime(handles);
handles=FillServoData(handles);

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using GestureTweak.
if strcmp(get(hObject,'Visible'),'off')
    handles=ServoPlot(hObject,handles);
    guidata(hObject,handles);
end

% Re-set up the Joint Select Pull Down with servo labels
JointSelectPullDown_CreateFcn(handles.JointSelectPullDown, eventdata, handles)


% UIWAIT makes GestureTweak wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GestureTweak_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(gcf);
printdlg(handles.PlotAxes)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)


% --- Executes on selection change in JointSelectPullDown.
function JointSelectPullDown_Callback(hObject, eventdata, handles)
% hObject    handle to JointSelectPullDown (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns JointSelectPullDown contents as cell array
%        contents{get(hObject,'Value')} returns selected item from JointSelectPullDown
handles.CurrentServo = get(handles.JointSelectPullDown, 'Value');
handles=ServoPlot(hObject,handles);
guidata(hObject, handles);
guidata(gcf, handles);      % Save handles to object and gcf



% --- Executes during object creation, after setting all properties.
function JointSelectPullDown_CreateFcn(hObject, eventdata, handles)
% hObject    handle to JointSelectPullDown (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

labels=[];
if ~isempty(handles)
    for i=1:handles.NumServos
        labels=strvcat(labels,handles.Servos(i).name);
    end
    set(hObject, 'String',labels);
else  % Default Servos
    set(hObject, 'String', {'FL Wing2', 'FL Crank2', 'FL Toe2',...
        'FR Wing2', 'FR Crank2', 'FR Toe2',...
        'RL Wing2', 'RL Crank2', 'RL Toe2',...
        'RR Wing2', 'RR Crank2', 'RR Toe2'});
end



% --- Executes on button press in GenerateGaitFileButton.
function GenerateGaitFileButton_Callback(hObject, eventdata, handles)
% hObject    handle to GenerateGaitFileButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
SaveMatV2(hObject,handles);



% --- Executes on selection change in GaitMatrixSelect.
function GaitMatrixSelect_Callback(hObject, eventdata, handles)
% hObject    handle to GaitMatrixSelect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns GaitMatrixSelect contents as cell array
%        contents{get(hObject,'Value')} returns selected item from GaitMatrixSelect
popup_sel_index = get(hObject, 'Value');

if handles.modified
    SaveMatV2(hObject,handles);
end

handles.servmat = evalin('base',handles.vars_mats(popup_sel_index,:));
% Added by BEH 3/23
handles.resample_points = size(handles.servmat,1);
% end addition
handles=FillServoData(handles);
handles.modified=false;

vars = evalin('base','whos');
handles.vars_mats = [];
for i=1:size(vars,1)
    if vars(i).size(2) == handles.NumServos+1
        handles.vars_mats = strvcat(handles.vars_mats,vars(i).name);
    end
end

if(size(handles.vars_mats,1)==0)
    set(handles.GaitMatrixSelect,'String',' ')
else
    set(handles.GaitMatrixSelect,'String',handles.vars_mats)
end
handles=UpdateTime(handles);
guidata(hObject, handles);
guidata(gcf, handles);

JointSelectPullDown_Callback(hObject, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function GaitMatrixSelect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GaitMatrixSelect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Plots a servos commands over time from the servomat
function handles=ServoMatPlot(hObject,handles)
%axes(handles.PlotAxes);
%cla;
if handles.Servos(handles.CurrentServo).rev == true
    temp=plot(handles.time,255-handles.servmat(:,handles.Servos(handles.CurrentServo).num+1));
else
    temp=plot(handles.time,handles.servmat(:,handles.Servos(handles.CurrentServo).num+1));
end
axis([0 max(handles.time) 0 255]);
xlabel('time (sec)');
ylabel(sprintf('%s                                              %s',...
    handles.Servos(handles.CurrentServo).downlabel,handles.Servos(handles.CurrentServo).uplabel));
grid on;
if handles.showmarkers==true
    set(temp,'Marker','o');
end
set(temp,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
set(gca,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
guidata(gcf, handles);

% --- Plots a servos commands over time from the servo's data structure
function handles=ServoPlot(hObject,handles)
currServ = handles.CurrentServo;
if handles.Servos(currServ).rev == true
    temp=plot(handles.Servos(currServ).time,255-handles.Servos(currServ).data);
else
    temp=plot(handles.Servos(currServ).time,handles.Servos(currServ).data);
end
axis([0 max(max(handles.Servos(currServ).time),1) 0 255]);
xlabel('time (sec)');
ylabel(sprintf('%s                                              %s',...
    handles.Servos(currServ).downlabel,handles.Servos(currServ).uplabel));
grid on;
if handles.showmarkers==true
    set(temp,'Marker','o');
end
set(temp,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
set(gca,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
guidata(gcf, handles);



% --- Converts data from servmat to servo data structure - eliminating
% excess sampled points, converting to lines.
function handles=FillServoData(handles)
handlesret = UpdateTime(handles);
orig_time = handlesret.time;
for i = 1:handles.NumServos
    data = handles.servmat(:,handles.Servos(i).num+1);
    diff_data = diff(data);
    handles.Servos(i).data = data(1);
    handles.Servos(i).time = orig_time(1);
    ind = 2;
    base = 1;
    endpt = base+1;
    while endpt<size(data,1)
        avg_slope = diff_data(base);
        run_slope = diff_data(endpt);
        if abs(avg_slope - run_slope) <= handles.slope_range
            run_slope = avg_slope;
        end
        while ( (abs(avg_slope-run_slope)<=0.1) && (endpt < size(data,1)-1))
            endpt = endpt+1;
            if (endpt-base) < 5
                avg_slope = diff_data(base);
                run_slope = diff_data(endpt);
                if abs(avg_slope - run_slope) <= handles.slope_range
                    run_slope = avg_slope;
                end
            else
                avg_slope = (data(endpt)-data(base))/(endpt-base);
                run_slope = (data(endpt)-data(endpt-4))/4;
            end
        end
        if (endpt-base) > 1
            endpt = endpt -1;
        end
        handles.Servos(i).data(ind) = data(endpt);
        handles.Servos(i).time(ind) = orig_time(endpt);
        base = endpt;
        endpt = base+1;
        ind = ind+1;
    end
    if max(handles.Servos(i).time) < max(orig_time);
        handles.Servos(i).data(ind) = data(size(data,1));
        handles.Servos(i).time(ind) = max(orig_time);
    end
    if size(handles.Servos(i).data,1) < size(handles.Servos(i).data,2)
        handles.Servos(i).data = handles.Servos(i).data';
    end
    if size(handles.Servos(i).time,1) < size(handles.Servos(i).time,2)
        handles.Servos(i).time = handles.Servos(i).time';
    end
end %debug: figure(2); plot(handles.Servos(i).time,handles.Servos(i).data,'ro',handles.time,handles.servmat(:,handles.Servos(i).num+1),'b+'); legend('new','old');
    
        
% --- Interpolates data in handles.Servos and returns the resulting matrix
function servmat=InterpolateMatrix(handles,num_points,min_time_step)
num_points = min(num_points, max(handles.time)/min_time_step+1);  % keep resolution step above min_time_step
time_vect = [0:round(max(handles.time)/(num_points-1)*1000)/1000:max(handles.time)]';
for i=1:handles.NumServos
    servmat(:,handles.Servos(i).num+1) = interp1(handles.Servos(i).time,handles.Servos(i).data,time_vect);
end
servmat = round(servmat);   % kick it into integers
servmat(:,handles.NumServos+1) = ones(size(servmat,1),1) * round(max(handles.time)/(num_points-1) * 1000);



% --- Saves Servo Commands in V2 Format
function SaveMatV2(hObject,handles)
%Save to file (stolen from Trey...)
servmat = InterpolateMatrix(handles,handles.resample_points,handles.MinTimeStep);
[nfile, pfile]=uiputfile('*.dat','Save As');
if not(isequal(nfile,0) | isequal(pfile,0))
    if length(nfile)<=3
        nfile=[nfile '.dat'];
    elseif strcmp(nfile(length(nfile)-3:length(nfile)),'.dat')~=1
        nfile=[nfile '.dat'];
    end
    eval(['fid=fopen(''' nfile ''',''w'');'])
    %Add the data for all the servos
    for i=1:size(servmat,1)
        %Write each column of data
        for j=1:size(servmat,2)-1
            fprintf(fid,'%d\t',servmat(i,j));
        end
        %Add the step duration info
        fprintf(fid,'%d\t\r',handles.servmat(i,size(servmat,2)));
    end
    fclose(fid);
    handles.modified=false;
    guidata(gcf,handles);
    guidata(hObject,handles);
end

% --- UpdatesTheTimeVector
function handlesret=UpdateTime(handles)
handles.time = [0];
for i=2:size(handles.servmat,1)
    handles.time(i) = handles.time(i-1)+handles.servmat(i-1,handles.TimeInd)/1000;
end
handlesret=handles;




% --- Executes on mouse press over axes background.
function PlotAxes_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to PlotAxes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles=guidata(gcf);   % replace handles with the figure's handles.
temp = get(handles.AddPointsButton);
temp2 = get(handles.MovePointsButton);
temp3 = get(handles.DeletePointsButton);
temp4 = get(handles.ShiftButton);
temp5 = get(handles.ShiftPhaseButton);
currServ = handles.CurrentServo;
if temp.Value       % Add Points
    tempax=get(handles.PlotAxes);
    point=tempax.CurrentPoint;
    point=[round(point(1,1)*1000)/1000, round(point(1,2))];
    handles=AddPoint(handles,currServ,point);
    handles=ServoPlot(hObject,handles);
elseif temp2.Value      % Move Points
    tempax=get(handles.PlotAxes);
    point=tempax.CurrentPoint;
    point=[round(point(1,1)*1000)/1000, round(point(1,2))];
    if handles.Servos(currServ).rev==true
        point(2) = 255-point(2);
    end
    index_high=min(find(handles.Servos(currServ).time>=point(1)));
    index_low=max(index_high - 1,1);
    dist_high =norm([(point(1)-handles.Servos(currServ).time(index_high))*100
        point(2) - handles.Servos(currServ).data(index_high)]);
    dist_low = norm([(point(1)-handles.Servos(currServ).time(index_low))*100
        point(2) - handles.Servos(currServ).data(index_low)]);
    if((dist_high<=dist_low) && (dist_high <= handles.distance))
        hold on;
        if handles.Servos(currServ).rev==true
            plot(handles.Servos(currServ).time(index_high),255-handles.Servos(currServ).data(index_high),'ks');
        else
            plot(handles.Servos(currServ).time(index_high),handles.Servos(currServ).data(index_high),'ks');
        end
        hold off;
        point2=ginput(1);
        point2=[round(point2(1,1)*1000)/1000, round(point2(1,2))];
        if ( (index_high>1) && (index_high<size(handles.Servos(currServ).data,1)) )  % Don't change time of endpoints
            handles = DeletePoint(handles,currServ,index_high);
            handles = AddPoint(handles,currServ,point2);
        else
            if handles.Servos(currServ).rev==true
                handles.Servos(currServ).data(index_high) = 255-point2(2);
            else
                handles.Servos(currServ).data(index_high) = point2(2);
            end
        end
        handles=ServoPlot(hObject,handles);
    elseif ((dist_low<dist_high) && (dist_low <= handles.distance))
        hold on;
        if handles.Servos(currServ).rev==true
            plot(handles.Servos(currServ).time(index_low),255-handles.Servos(currServ).data(index_low),'ks');
        else
            plot(handles.Servos(currServ).time(index_low),handles.Servos(currServ).data(index_low),'ks');
        end
        hold off;
        point2=ginput(1);
        point2=[round(point2(1,1)*1000)/1000, round(point2(1,2))];
        if ( (index_low>1) && (index_low<size(handles.Servos(currServ).data,1)) )  % Don't change time of endpoints
            handles = DeletePoint(handles,currServ,index_low);
            handles = AddPoint(handles,currServ,point2);
        else
            if handles.Servos(currServ).rev==true
                handles.Servos(currServ).data(index_low) = 255-point2(2);
            else
                handles.Servos(currServ).data(index_low) = point2(2);
            end
        end
        handles=ServoPlot(hObject,handles);
    end
    set(handles.PlotAxes,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
    guidata(gcf, handles);
elseif temp3.Value      % Delete Points
    tempax=get(handles.PlotAxes);
    point=tempax.CurrentPoint;
    point=[round(point(1,1)*1000)/1000, round(point(1,2))];
    if handles.Servos(currServ).rev==true
        point(2) = 255-point(2);
    end
    index_high=min(find(handles.Servos(currServ).time>=point(1)));
    index_low=max(index_high - 1,1);
    dist_high =norm([(point(1)-handles.Servos(currServ).time(index_high))*100
        point(2) - handles.Servos(currServ).data(index_high)]);
    dist_low = norm([(point(1)-handles.Servos(currServ).time(index_low))*100
        point(2) - handles.Servos(currServ).data(index_low)]);
    if( (dist_high <= dist_low) && (dist_high <= handles.distance) )
        handles=DeletePoint(handles,currServ,index_high);
        handles=ServoPlot(hObject,handles);
    elseif ( (dist_low <= handles.distance) && (index_low > 1) )
        handles=DeletePoint(handles,currServ,index_low);
        handles=ServoPlot(hObject,handles);
    end
    set(handles.PlotAxes,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
elseif temp4.Value    % Shift Plot Offset
    tempax=get(handles.PlotAxes);
    point=tempax.CurrentPoint;
    point=[round(point(1,1)*1000)/1000, round(point(1,2))];
    hold on;
    plot(point(1),point(2),'kd');       % Drop a marker on the selected point
    hold off;
    point2=ginput(1);
    point2=[round(point2(1,1)*1000)/1000, round(point2(1,2))];
    offset = point2(2)-point(2);
    if handles.Servos(currServ).rev==true
        offset = -1*offset;             % Flip offset for reversed servos
    end
    handles.Servos(currServ).data = handles.Servos(currServ).data + offset;
    handles.Servos(currServ).data = min(handles.Servos(currServ).data,255);    % Max limit = 255
    handles.Servos(currServ).data = max(handles.Servos(currServ).data,0);      % Min limit = 0
    handles=ServoPlot(hObject,handles);
    set(handles.PlotAxes,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
elseif temp5.Value      % Shift Phase
    tempax=get(handles.PlotAxes);
    point=tempax.CurrentPoint;
    point=[round(point(1,1)*1000)/1000, round(point(1,2))];
    hold on;
    plot(point(1),point(2),'kh');       % Drop a marker on the selected point
    hold off;
    point2=ginput(1);
    point2=[round(point2(1,1)*1000)/1000, round(point2(1,2))];
    offset = point2(1)-point(1);
    offset = round(offset*1000)/1000;
    % store length of trajectory
    period = max(handles.Servos(currServ).time)+handles.MinTimeStep;
    % Apply offset to time
    handles.Servos(currServ).time = handles.Servos(currServ).time + offset;
    % Add points at zero or period (interpolate) (they're the same
    % point...)  Re-order...
    if offset < 0
        newdata=interp1(handles.Servos(currServ).time,handles.Servos(currServ).data,0);
        if handles.Servos(currServ).rev==true
            newdata=255-newdata;  % It gets re-flipped in AddData
        end
        handles = AddPoint(handles,currServ,[0,newdata],true);
        handles = AddPoint(handles,currServ,[-handles.MinTimeStep,newdata],false);  % wrap point
        index = max(find(handles.Servos(currServ).time<0));
        handles.Servos(currServ).time = ...
            [handles.Servos(currServ).time(index+1:size(handles.Servos(currServ).time,1))
             handles.Servos(currServ).time(1:index)+period];
        handles.Servos(currServ).data = ...
            [handles.Servos(currServ).data(index+1:size(handles.Servos(currServ).data,1))
             handles.Servos(currServ).data(1:index)];
        handles = CleanUpShift(handles);
        handles=ServoPlot(hObject,handles);
    elseif offset > 0
        newdata=interp1(handles.Servos(currServ).time,handles.Servos(currServ).data,period);
        if handles.Servos(currServ).rev==true
            newdata=255-newdata;  % It gets re-flipped in AddData
        end
        handles = AddPoint(handles,currServ,[period,newdata],true);
        handles = AddPoint(handles,currServ,[period-handles.MinTimeStep,newdata],false);  % wrap point
        index = min(find(handles.Servos(currServ).time>=period));
        handles.Servos(currServ).time = ...
            [handles.Servos(currServ).time(index:size(handles.Servos(currServ).time,1))-period
             handles.Servos(currServ).time(1:index-1)];
        handles.Servos(currServ).data = ...
            [handles.Servos(currServ).data(index:size(handles.Servos(currServ).data,1))
             handles.Servos(currServ).data(1:index-1)];
        handles = CleanUpShift(handles);
        handles=ServoPlot(hObject,handles);
    end
    set(handles.PlotAxes,'ButtonDownFcn',{@PlotAxes_ButtonDownFcn,handles});
end
guidata(gcf, handles);

% --- Deletes a data point
function handles=DeletePoint(handles,servo,index)
if ( (index>1) & (index<size(handles.Servos(servo).data,1)) ) % Don't delete endpoints
handles.Servos(servo).data=[handles.Servos(servo).data(1:index-1)
    handles.Servos(servo).data(index+1:size(handles.Servos(servo).data,1))];
handles.Servos(servo).time=[handles.Servos(servo).time(1:index-1)
    handles.Servos(servo).time(index+1:size(handles.Servos(servo).time,1))];
handles.modified=true;
end

% --- Adds a data point 
function handles=AddPoint(handles,servo,point,ignore_close)
if nargin<4
    ignore_close=false;
end
index=min(find(handles.Servos(servo).time>=point(1)));
if handles.Servos(servo).rev==true
    point(2) = 255-point(2);
end
if isempty(index)   % Add point at end of data - should only happen with a phase shift
    index = size(handles.Servos(servo).time,1)+1;
    handles.Servos(servo).time(index) = point(1);
    handles.Servos(servo).data(index) = point(2);
else
    if (handles.Servos(servo).time(index)-point(1) < handles.MinTimeStep)  && ~ignore_close
        handles.Servos(servo).data(index)=point(2);
        handles.modified=true;
    else
        if index>1  %Can't insert before first point
            handles.Servos(servo).data=[handles.Servos(servo).data(1:index-1)
                point(2);
                handles.Servos(servo).data(index:size(handles.Servos(servo).data,1))];
            handles.Servos(servo).time=[handles.Servos(servo).time(1:index-1)
                point(1);
                handles.Servos(servo).time(index:size(handles.Servos(servo).time,1))];
            handles.modified=true;
        end
    end
end


% --- Deletes extraneous points which occur when time shifting
function handles=CleanUpShift(handles)
currServ = handles.CurrentServo;
diff_time = diff(handles.Servos(currServ).time);
indices1 = find(diff_time<=handles.MinTimeStep*1.1);
diff_value = diff(handles.Servos(currServ).data);
indices2 = find(diff_value==0);
indices = intersect(indices1,indices2);
while ~isempty(indices)
    if indices(1)+1 < size(handles.Servos(currServ).time,1)
        handles=DeletePoint(handles,currServ,indices(1)+1);
    else
        handles=DeletePoint(handles,currServ,indices(1));
    end
    diff_time = diff(handles.Servos(currServ).time);
    indices1 = find(diff_time<=handles.MinTimeStep);
    diff_value = diff(handles.Servos(currServ).data);
    indices2 = find(diff_value==0);
    indices = intersect(indices1,indices2);
end

    
    

% --- Executes on button press in ShowPointsToggle.
function ShowPointsToggle_Callback(hObject, eventdata, handles)
% hObject    handle to ShowPointsToggle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
temp = get(gca,'Children');

if handles.showmarkers    % Turn off Markers
    set(temp,'Marker','none');
    handles.showmarkers = false;
    set(hObject,'String','Show Points');
else
    set(temp,'Marker','o');
    handles.showmarkers = true;
    set(hObject,'String','Hide Points');
end
guidata(gcf,handles);
guidata(hObject,handles);


% --- Executes on button press in AddPointsButton.
function AddPointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to AddPointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AddPointsButton
if get(handles.AddPointsButton,'Value')==1
    set(handles.DeletePointsButton,'Value',0);
    set(handles.MovePointsButton,'Value',0);
    set(handles.ShiftButton,'Value',0);
    set(handles.ShiftPhaseButton,'Value',0);
end
guidata(gcf,handles);
guidata(hObject,handles);


% --- Executes on button press in DeletePointsButton.
function DeletePointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to DeletePointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of DeletePointsButton
if get(handles.DeletePointsButton,'Value')==1
    set(handles.AddPointsButton,'Value',0);
    set(handles.MovePointsButton,'Value',0);
    set(handles.ShiftButton,'Value',0);
    set(handles.ShiftPhaseButton,'Value',0);
end
guidata(gcf,handles);
guidata(hObject,handles);

% --- Executes on button press in MovePointsButton.
function MovePointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to MovePointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of MovePointsButton
if get(handles.MovePointsButton,'Value')==1
    set(handles.AddPointsButton,'Value',0);
    set(handles.DeletePointsButton,'Value',0);
    set(handles.ShiftButton,'Value',0);
    set(handles.ShiftPhaseButton,'Value',0);
end
guidata(gcf,handles);
guidata(hObject,handles);


% --- Executes on button press in ShiftButton.
function ShiftButton_Callback(hObject, eventdata, handles)
% hObject    handle to ShiftButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ShiftButton
if get(handles.ShiftButton,'Value')==1
    set(handles.AddPointsButton,'Value',0);
    set(handles.DeletePointsButton,'Value',0);
    set(handles.MovePointsButton,'Value',0);
    set(handles.ShiftPhaseButton,'Value',0);
end
guidata(gcf,handles);
guidata(hObject,handles);


% --- Executes on button press in ShiftPhaseButton.
function ShiftPhaseButton_Callback(hObject, eventdata, handles)
% hObject    handle to ShiftPhaseButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ShiftPhaseButton
if get(handles.ShiftPhaseButton,'Value')==1
    set(handles.AddPointsButton,'Value',0);
    set(handles.DeletePointsButton,'Value',0);
    set(handles.MovePointsButton,'Value',0);
    set(handles.ShiftButton,'Value',0);
end
guidata(gcf,handles);
guidata(hObject,handles);



% --------------------------------------------------------------------
function uipanel5_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to uipanel5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in CopyGaitButton.
function CopyGaitButton_Callback(hObject, eventdata, handles)
% hObject    handle to CopyGaitButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(gcf);
currServ = handles.CurrentServo;
joint = CopyJointSelectPopUp(get(handles.JointSelectPullDown,'String'));
if (joint > 0) && (joint <= handles.NumServos) && (joint ~= currServ)
    handles.Servos(joint).data = handles.Servos(currServ).data;
    handles.Servos(joint).time = handles.Servos(currServ).time;
    if handles.Servos(joint).rev ~= handles.Servos(currServ).rev
        handles.Servos(joint).data = 255 - handles.Servos(joint).data;
    end
end
guidata(gcf,handles);
guidata(hObject,handles);






% --------------------------------------------------------------------
function SaveMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to SaveMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(gcf);
SaveMatV2(hObject,handles);





% --- Executes on button press in EditPointsButton.
function EditPointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to EditPointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(gcf);
currServ = handles.CurrentServo;
currData = [handles.Servos(currServ).time handles.Servos(currServ).data];
if handles.Servos(currServ).rev == true
    currData(:,2) = 255 - currData(:,2);
end
newDataCell = tableGUI('array',currData,'ColNames',{'Time','Value'},'FigName',...
    sprintf('Servo #%d',handles.Servos(currServ).num));
if length(newDataCell) > 1
    for i=1:size(newDataCell,1)
        newData(i,1) = str2num(newDataCell{i,1});
        newData(i,2) = str2num(newDataCell{i,2});
    end
    if handles.Servos(currServ).rev == true
        newData(:,2) = 255 - newData(:,2);
    end
    newData = sortrows(newData,1);          % sort by time
    newData = [round(newData(:,1)*1000)/1000, round(newData(:,2))];  % round input values to milli-seconds & servo counts
    maxIndex = max(find(newData(:,1)<=max(currData(:,1))));
    newData = newData(1:maxIndex,:);        % remove data points > period
    newData(:,2) = max(newData(:,2),0);     % Ensure that data >= 0
    newData(:,2) = min(newData(:,2),255);   % Ensure that data <= 255
    handles.Servos(currServ).time = newData(:,1);
    handles.Servos(currServ).data = newData(:,2);
    handles = ServoPlot(hObject,handles);
    guidata(gcf,handles);
end


